SystemOrganization addCategory: #ZipperControl!
SystemOrganization addCategory: #'ZipperControl-Tests'!

!BlockClosure methodsFor: '*ZipperControl' stamp: 'fbs 6/22/2011 07:36'!
compose: aUnaryBlock
	^ [:x | self value: (aUnaryBlock value: x)].! !

Object subclass: #Zipper
	instanceVariableNames: 'node continuation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZipperControl'!

!Zipper commentStamp: 'fbs 6/13/2011 07:47' prior: 0!
I am a suspended walk over an enumeration. That is, given a traversal strategy and a data structure, I allow for the traversal of that data structure. I also allow for copy-on-write mutation that shares structure between the old and new versions of a structure as much as my underlying enumerator allows.

In particular, my enumerator either returns false or a replacement node.!

Zipper subclass: #ZipDone
	instanceVariableNames: 'term'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZipperControl'!

!ZipDone class methodsFor: 'instance creation' stamp: 'fbs 6/14/2011 18:18'!
on: anObject
	^ self new on: anObject.! !

!ZipDone methodsFor: 'testing' stamp: 'fbs 6/22/2011 07:32'!
atEnd
	^ true.! !

!ZipDone methodsFor: 'accessing' stamp: 'fbs 6/14/2011 18:15'!
term
	^ term! !

!ZipDone methodsFor: 'private' stamp: 'fbs 6/14/2011 18:15'!
term: anObject
	term := anObject.! !

!ZipDone methodsFor: 'applying' stamp: 'fbs 6/14/2011 18:39'!
zipUp
	^ term.! !

!Zipper class methodsFor: 'instance creation' stamp: 'fbs 6/14/2011 18:18'!
on: anObject with: aBinaryBlock
	^ self new on: anObject with: aBinaryBlock! !

!Zipper class methodsFor: 'enumerating' stamp: 'fbs 6/21/2011 22:36'!
zipOver: aCollection
	"Turn an enumeration inside out: return a zipper on a traversal such that the continuation associated with the traversal takes a Maybe. If the value's Nothing, leave the value associated with the zipper unchanged; otherwise, replace it with the Just value."
	| f maybeUpdate |
	"maybeUpdate returns the value to be associated with the zipper: either the original element, or its replacement."
	maybeUpdate := [:x | x maybe: #yourself default: x].
	f := [:a | [:k| Zipper on: a with: (k compose: maybeUpdate)] shift].
	^ [aCollection collect: [:each | f value: each] , (ZipDone on: aCollection) ] reset.! !

!Zipper methodsFor: 'testing' stamp: 'fbs 6/22/2011 07:32'!
atEnd
	^ false.! !

!Zipper methodsFor: 'accessing' stamp: 'fbs 6/17/2011 07:46'!
continuation
	^ continuation.! !

!Zipper methodsFor: 'accessing' stamp: 'fbs 6/17/2011 07:46'!
node
	^ node.! !

!Zipper methodsFor: 'private' stamp: 'fbs 6/14/2011 18:19'!
on: anObject with: aBinaryBlock
	node := anObject.
	continuation := aBinaryBlock.! !

!Zipper methodsFor: 'applying' stamp: 'fbs 6/14/2011 18:46'!
zipUp
	^ continuation value: Maybe nothing.! !

Object subclass: #ZipperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ZipperControl-Tests'!

!ZipperTest methodsFor: 'testing - enumerating' stamp: 'fbs 6/22/2011 07:28'!
testEnumerationUsingNothingSimplyEnumerates
	| coll z |
	coll := #(1 2 3).
	z := Zipper zipOver: coll.
	[z atEnd] whileFalse: [z := z continuation value: Maybe nothing].
	self assert: z zipUp = coll.! !
